
#include "key.h"

uint8_t key_state;                  	// debounced and inverted key state:
                          	  	// bit = 1: key pressed
uint8_t key_press;                  	// key press detect

uint8_t key_rpt;                    	// key long press and repeat

uint8_t get_key_press( uint8_t key_mask )
{
  cli();                    	// Master Interrupts sperren
  key_mask &= key_press;        // read key(s)
  key_press ^= key_mask;        // clear key(s)
  sei();              			// Master Interrupts freigeben
  return key_mask;
}


uint8_t get_key_rpt( uint8_t key_mask )
{
  cli();                    	// Master Interrupts sperren
  key_mask &= key_rpt;          // read key(s)
  key_rpt ^= key_mask;          // clear key(s)
  sei();              			// Master Interrupts freigeben
  return key_mask;
}


uint8_t get_key_short( uint8_t key_mask )
{
  cli();      // Master Interrupts sperren
  return get_key_press( ~key_state & key_mask );
}


uint8_t get_key_long( uint8_t key_mask )
{
  return get_key_press( get_key_rpt( key_mask ));
}


