#ifndef __TASTENPRELLEN_H
#define __TASTENPRELLEN_H

#include "LPC17xx.h"
#include "type.h"


#define KEY_PIN  (LPC_GPIO2->FIOPIN)

#define KEY0    2
#define KEY1    3
#define KEY2    4
#define KEY3    5

#define REPEAT_MASK  (1<<KEY2)  // repeat: key2
#define REPEAT_START  50          // after 500ms
#define REPEAT_NEXT   20            // every 200ms

#define sei() NVIC_EnableIRQ(TIMER0_IRQn);
#define cli() NVIC_DisableIRQ(TIMER0_IRQn);

uint8_t key_state,key_press,key_rpt;   	// debounced and inverted key state:

uint8_t get_key_press( uint8_t key_mask );
uint8_t get_key_rpt( uint8_t key_mask );
uint8_t get_key_short( uint8_t key_mask );
uint8_t get_key_long( uint8_t key_mask );



#endif
