/****************************************************************************

 // 4 Keys testen mit Entprellung (Peter Danneger)
 // Key1 bis Key4 externer Widerstand GPIO2-2 bis GPIO2-5,
 // Board NXP J6-44 bis J6-47
 / ****************************************************************************/


#include "tools.h"                        /* LPC17xx definitions */



/******************************************************************************
**   Main Function  main()
******************************************************************************/
int main (void)
{
  /* SystemClockUpdate() updates the SystemFrequency variable */
	SystemCoreClockUpdate();

	delay_ms(10);  		// 10ms warten Display Init

	// Port für Key und LED vorbereiten
	LPC_GPIO0->FIODIR |= 1 << 22;	// LED2 on Board
	LPC_GPIO0->FIOCLR |= 1 << 22;

	LPC_GPIO2->FIODIR |= 1 << 6;  	// Test LED1 J6-48
	LPC_GPIO2->FIOCLR |= 1 << 6;
	LPC_GPIO2->FIODIR |= 1 << 7;  	// Test LED2 J6-49
	LPC_GPIO2->FIOCLR |= 1 << 7;
	LPC_GPIO2->FIODIR |= 1 << 8;	// Test LED3 J6-50
	LPC_GPIO2->FIOCLR |= 1 << 8;

	//LPC_GPIO2->FIOSET |= 1 << 7;

	LPC_PINCON->PINMODE0 &= ~(1<<2); // Key0 bis Key3 externer Widerstand GPIO2-2 bis GPIO2-5
	LPC_PINCON->PINMODE0 &= ~(1<<3); //	J6-44 bis J6-47
	LPC_PINCON->PINMODE0 &= ~(1<<4);
	LPC_PINCON->PINMODE0 &= ~(1<<5);

	init_rit_timer( TIME_INTERVAL );		/* 10ms */
	enable_rit_timer();


	  while (1)
	  {					/* Loop forever */


		  //----------------------------- Taster abfragen----------------

		if( get_key_press( 1<<KEY0 ))
		    {
			LPC_GPIO2->FIOSET |= 1 << 6;		// LED1 on

		    }


		    if( get_key_press( 1<<KEY1 ))
		    {
		    LPC_GPIO2->FIOCLR |= 1 << 6;		// LED1 off

		    }

		    if( get_key_press( 1<<KEY2 ))
		    {
		    LPC_GPIO2->FIOSET |= 1 << 7;		// LED2 on

		    }

		    if( get_key_press( 1<<KEY3 ))
			 {
		     LPC_GPIO2->FIOCLR |= 1 << 7;		// LED2 off

			 }


	  }


 return 0;
}//----------------------------------------Ende while()------------------------

void delay_ms( uint32_t delayInMs)
{
    LPC_TIM1->TCR=0x02;
    LPC_TIM1->IR=0xFF;
    LPC_TIM1->MR0=delayInMs*9000000/1000-1;
    LPC_TIM1->MCR=0x04;
    LPC_TIM1->TCR=0x01;
    while(LPC_TIM1->TCR&0x01);

 return;
}


void delay_us( uint32_t delayInMs)
{
    LPC_TIM1->TCR=0x02;
    LPC_TIM1->IR=0xFF;
    LPC_TIM1->MR0=delayInMs*9000/1000-1;
    LPC_TIM1->MCR=0x04;
    LPC_TIM1->TCR=0x01;
    while(LPC_TIM1->TCR&0x01);

 return;
}


void RIT_IRQHandler (void)
{

	LPC_RIT->RICTRL |= (0x1<<0);	/* clear interrupt flag */

	static uint8_t ct0, ct1, rpt;
	  	   uint8_t i;

	  i = key_state ^ ~KEY_PIN;      // key changed ?
	  ct0 = ~( ct0 & i );      // reset or count ct0
	  ct1 = ct0 ^ (ct1 & i);    // reset or count ct1
	  i &= ct0 & ct1;      // count until roll over ?
	  key_state ^= i;      // then toggle debounced state
	  key_press |= key_state & i;    // 0->1: key press detect

	  if( (key_state & REPEAT_MASK) == 0 )  // check repeat function
	     rpt = REPEAT_START;    // start delay
	  if( --rpt == 0 ){
	    rpt = REPEAT_NEXT;      // repeat delay
	    key_rpt |= key_state & REPEAT_MASK;
	  }

  return;
}


/******************************************************************************
**                            End Of File
******************************************************************************/

